package gw.test;

import java.lang.reflect.Method;
import java.util.Properties;

import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.ObjectMessage;
import javax.jms.Queue;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueSender;
import javax.jms.QueueSession;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;


import gw.beans.Router;

public class RouterManagerBeanJ6Test {

	private QueueConnection conn;
	private QueueSession session;
	private Queue queue;
	
	public static void main(String[] args) throws NamingException, JMSException, InterruptedException {
		
		routerBeanConn();
		
		//RouterManagerBeanJ6Test a = new RouterManagerBeanJ6Test();
		//a.send("HI");
		
		
		System.out.println("HI");
		
		
	}
	
	public static void routerBeanConn() throws NamingException{
		Properties env = new Properties();
		env.put("java.naming.factory.initial", "org.jnp.interfaces.NamingContextFactory");
		env.put("java.naming.factory.url.pkgs", "org.jboss.naming:org.jnp.interfaces");
		env.put("java.naming.provider.url", "jnp://localhost:1099");
		Context ctx = new InitialContext(env);
		Router router = (Router) ctx.lookup("gw-app-server/RouterBean/remote");
		router.processMessage(null);
	}
	
	public void send(String textBase) throws JMSException, NamingException, InterruptedException {
		Properties env = new Properties();
		env.put("java.naming.factory.initial", "org.jnp.interfaces.NamingContextFactory");
		env.put("java.naming.factory.url.pkgs", "org.jboss.naming:org.jnp.interfaces");
		env.put("java.naming.provider.url", "jnp://localhost:1099");
		InitialContext ic = new InitialContext(env);
		Object tmp = ic.lookup("XAConnectionFactory");
		QueueConnectionFactory qcf = (QueueConnectionFactory) tmp;
		
		conn = qcf.createQueueConnection();
		queue = (Queue) ic.lookup("GW-Test");
		session = conn.createQueueSession(false, QueueSession.AUTO_ACKNOWLEDGE);
		conn.start();

		// Send a few text msgs to queB
		QueueSender send = session.createSender(queue);

		long t0 = System.currentTimeMillis();
		long tf = 0;
		
			
		ObjectMessage objMessage = session.createObjectMessage(textBase);
		objMessage.setJMSReplyTo(queue);
		
		send.send(objMessage);

		
		tf = System.currentTimeMillis();
		
		System.out.println("Time Elapsed: " + (tf - t0) + " miliseconds");
		
	}
	
}
