package gw.queue;

import gw.beans.Router;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.Message;
import javax.jms.MessageConsumer;
import javax.jms.MessageListener;
import javax.jms.Queue;
import javax.jms.Session;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class Consumer implements MessageListener{

	public static Router router;
	
	static{
		try {
			Context ctx = new InitialContext();
			router = (Router) ctx.lookup("gw-app-server/RouterBean/remote");
			
			System.out.println("INIT ROUTER");
			
		} catch (NamingException e) {
			e.printStackTrace();
		}
	}
	
	public Consumer(){
		
		
	}
	
	@Override
	public void onMessage(Message msg) {
		try{
			router.processMessage(msg);
		}catch (Exception e) {
			e.printStackTrace();
		}
	}

}
